local UIItem = {}

local equipFlagRes = {
	[Const.ITEM_WEAPON_POSITION] 	=	"equip_flag_weapon",
	[Const.ITEM_CLOTH_POSITION] 	=	"equip_flag_cloth",
	[Const.ITEM_GLOVE1_POSITION] 	=	"equip_flag_glove",
	[Const.ITEM_RING1_POSITION] 	=	"equip_flag_ring",
	[Const.ITEM_BOOT_POSITION] 		=	"equip_flag_boot",
	[Const.ITEM_HAT_POSITION] 		=	"equip_flag_hat",	
	[Const.ITEM_NICKLACE_POSITION] 	=	"equip_flag_necklace",
	[Const.ITEM_GLOVE2_POSITION] 	=	"equip_flag_glove",
	[Const.ITEM_RING2_POSITION] 	=	"equip_flag_ring",
	[Const.ITEM_BELT_POSITION] 		=	"equip_flag_belt",

	--玉佩
	[Const.ITEM_JADE_PENDANT_POSITION] = "equip_flag_jade_pendant",
	--护盾
	[Const.ITEM_SHIELD_POSITION] = "equip_flag_shield",
	--护心镜
	[Const.ITEM_MIRROR_ARMOUR_POSITION] = "equip_flag_mirror_armour",
	--面巾
	[Const.ITEM_FACE_CLOTH_POSITION] = "equip_flag_face_cloth",
	--龙心
	[Const.ITEM_DRAGON_HEART_POSITION] = "equip_flag_dragon_heart",
	--狼牙
	[Const.ITEM_WOLFANG_POSITION] = "equip_flag_wolfang",
	--龙骨
	[Const.ITEM_DRAGON_BONE_POSITION] = "equip_flag_dragon_bone",
	--虎符
	[Const.ITEM_CATILLA_POSITION] = "equip_flag_catilla",
	

	

	[Const.ITEM_TEJIE1_POSITION] = "equip_flag_tering",
	--特戒2
	[Const.ITEM_TEJIE2_POSITION] = "equip_flag_tering",

}

local function newItem(pSize)
	local itemIcon = ccui.Widget:create()
		:setName("item_icon")
		:setContentSize(pSize)

	local imgIconInner = ccui.ImageView:create("null", ccui.TextureResType.plistType)
		:align(display.CENTER, pSize.width * 0.5, pSize.height * 0.5+2)
		:addTo(itemIcon)
		:hide()
		:setName("img_icon_inner")

	local imgEquipFlag = ccui.ImageView:create("null", ccui.TextureResType.plistType)
		:align(display.CENTER, pSize.width * 0.5, pSize.height * 0.5)
		:addTo(itemIcon)
		-- :hide()
		:setName("img_equip_flag")

	local size = imgIconInner:getContentSize()
	imgIconInner:setScale(pSize.width / size.width)

	-- 品质背景
	ccui.ImageView:create()
		:align(display.CENTER, pSize.width * 0.5, pSize.height * 0.5)
		:addTo(itemIcon)
		:hide()
		:setName("img_icon_bg")

	-- icon图片
	ccui.ImageView:create()
		:align(display.CENTER, pSize.width * 0.5, pSize.height * 0.5)
		:addTo(itemIcon)
		:setName("img_icon")

	--强化等级
	ccui.Text:create()
		:align(display.RIGHT_TOP, (pSize.width<=60 and pSize.width * 0.95 or pSize.width * 0.9), (pSize.height<=60 and pSize.height*1 or pSize.height*0.9))
		:setFontName(FONT_NAME)
		:addTo(itemIcon)
		:setFontSize(16)
		:setName("lbl_upd_level")
		:enableOutline(game.getColor(0x000000),1)

	--注灵等级(装备)
	ccui.Text:create()
		:align(display.RIGHT_BOTTOM, pSize.width * 0.9, pSize.height*0.1)
		:setFontName(FONT_NAME)
		:addTo(itemIcon)
		:setFontSize(20)
		:setName("lbl_zl_level")

	--数量 暂时写死
	ccui.Text:create()
		:align(display.RIGHT_BOTTOM, pSize.width * 0.9, pSize.height * 0.1)
		:enableOutline(game.getColor(0x000000),1)
		:setFontName(FONT_NAME)
		:addTo(itemIcon)
		:setFontSize(16)
		:setName("lbl_num")

	-- 绑定标志
	ccui.ImageView:create("lock", ccui.TextureResType.plistType)
		:align(display.LEFT_BOTTOM, pSize.width * 0.1, pSize.height * 0.1)
		:addTo(itemIcon)
		:hide()
		:setName("img_bind_mark")

	-- 红点
	ccui.ImageView:create("img_arrow_attr_up", ccui.TextureResType.plistType)
		:align(display.LEFT_TOP, pSize.width * 0.1, pSize.height * 0.9)
		:addTo(itemIcon)
		:hide()
		:setName("img_better_equip")

	ccui.ImageView:create("img_red_point", ccui.TextureResType.plistType)
		:align(display.CENTER, pSize.width * 0.81, pSize.height * 0.81)
		:addTo(itemIcon)
		:hide()
		:setName("img_use_item")
	return itemIcon
end

local function resetItem(itemIcon)
	if itemIcon then
		-- print("resetItem",itemIcon)
		itemIcon:getWidgetByName("img_icon"):loadTexture("null", ccui.TextureResType.plistType)
		itemIcon:getWidgetByName("img_icon_bg"):loadTexture("null", ccui.TextureResType.plistType)
		-- itemIcon.itemPos = nil
		itemIcon.typeId = nil
		itemIcon.mLevel = nil
		itemIcon.mClickTime = 0
		itemIcon.showBetter = nil
		if game.itemSchedule then
			Scheduler.unscheduleGlobal(game.itemSchedule)
			game.itemSchedule = nil
		end

		-- itemIcon.updateFunc = nil
		-- itemIcon.itemCallBack = nil
		itemIcon:getWidgetByName("lbl_upd_level"):setString("")
		itemIcon:getWidgetByName("lbl_zl_level"):setString("")
		itemIcon:getWidgetByName("lbl_num"):setString("")
		itemIcon:getWidgetByName("img_better_equip"):hide()
		itemIcon:getWidgetByName("img_bind_mark"):hide()
		itemIcon:getWidgetByName("img_icon_inner"):hide()
		itemIcon:getWidgetByName("img_use_item"):stopAllActions():hide()
	end
end

local function singleClickItem(sender)
	-- print("singleClickItem");
	local itemIcon = sender.itemIcon
	if itemIcon then
		--张思帆说可以去掉限制----------还是加上吧
		if Const.ICONTYPE.DEPOT==itemIcon.iconType or Const.ICONTYPE.NOTIP==itemIcon.iconType then
			if itemIcon.callBack then itemIcon.callBack() end
		else
			NetClient:dispatchEvent({
				name		= Notify.EVENT_HANDLE_TIPS, 
				itemPos		= itemIcon.itemPos, 
				typeId		= itemIcon.typeId,
				mLevel		= itemIcon.mLevel,
				mZLevel		= itemIcon.mZLevel,
				-- iconType    = itemIcon.iconType,
				tipsType	= itemIcon.tipsType,
				customCallFunc = itemIcon.customCallFunc,
				destoryCallFunc = itemIcon.destoryCallFunc,
				visible		= true,
				compare		= itemIcon.compare,
				enmuPos 	= itemIcon.enmuPos,
				enmuItemType = itemIcon.enmuItemType,
			})
		end
	end
end

local function doubleClickItem(sender)
	-- print("doubleClickItem");
	local itemIcon = sender.itemIcon
	if itemIcon.doubleCall then
		itemIcon.doubleCall()
	elseif Const.ICONTYPE.BAG == itemIcon.iconType then
		local netItem = NetClient:getNetItem(itemIcon.itemPos)
		if netItem then
			if game.canBatchUse(netItem.mTypeID) then
				NetClient:BagUseItem(itemIcon.itemPos, netItem.mTypeID,netItem.mNumber)
			else
				NetClient:BagUseItem(itemIcon.itemPos, netItem.mTypeID)
			end
		end
	end
end

local function handleEquipFlag(itemIcon)
	itemIcon:getWidgetByName("img_equip_flag"):loadTexture("null", ccui.TextureResType.plistType)
	if itemIcon.itemPos and itemIcon.itemPos < 0 and itemIcon.mShowEquipFlag then
		local netItem = NetClient:getNetItem(itemIcon.itemPos)
		if not netItem and equipFlagRes[itemIcon.itemPos] then
			itemIcon:getWidgetByName("img_equip_flag"):loadTexture(equipFlagRes[itemIcon.itemPos], ccui.TextureResType.plistType)
		end
	end
end

--背包格子红点动画
local function handleRedPoint(itemIcon, netItem)
	itemIcon:getWidgetByName("img_use_item"):stopAllActions():hide()
	-- print("////////////////////////////////", netItem.position, game.IsPosInBag(netItem.position), game.checkItemShowUse(netItem.mTypeID))
	if game.IsPosInBag(netItem.position) and game.checkItemShowUse(netItem.mTypeID) then
		local milliSecond = math.floor(game.getTime() % 1000 - 500)
		local scale = 1
		if milliSecond >= 0 then
			scale = 1.1 - (0.2 * milliSecond / 500)
		else
			scale = 0.9 + (0.2 * (500 + milliSecond) / 500)
		end

		local function scaleActionA (sender)
			if sender then sender:runAction(cca.repeatForever(cca.seq({cca.scaleTo(0.5, 1.1), cca.scaleTo(0.5, 0.9)}))) end
		end

		local function scaleActionB (sender)
			if sender then sender:runAction(cca.repeatForever(cca.seq({cca.scaleTo(0.5, 0.9), cca.scaleTo(0.5, 1.1)}))) end
		end

		local imgUseItem = itemIcon:getWidgetByName("img_use_item"):show():scale(scale)
		if milliSecond > 0 then
			imgUseItem:runAction(cca.seq({
				cca.scaleTo((500 - milliSecond) / 1000, 0.9),
				cca.cb(scaleActionA)
			}))
		else
			imgUseItem:runAction(cca.seq({
				cca.scaleTo(-milliSecond / 1000, 1.1),
				cca.cb(scaleActionB)
			}))
		end
	end
end

--整理使用批量刷新，不执行单个刷新
local function canItemFresh(pos)
	local can = true
	if NetClient.mSortFlag then
		if NetClient.mSortFlag == 0 then --背包
			if game.IsPosInBag(pos) then can = false end
		elseif NetClient.mSortFlag == 1 then -- 仓库
			if game.IsPosInDepot(pos) then can = false end
		-- elseif NetClient.mSortFlag == 3 then -- 寻宝
		-- 	if game.IsPosInLottoryDepot(pos) then can = false end
		end
	end
	-- print("canItemFresh", NetClient.mSortFlag, pos, can)
	return can
end

function UIItem.getItem(param)
	if param.parent then
		local itemIcon = param.parent:getWidgetByName("item_icon")
		-- print("UIItem.getItem", itemIcon)
		if not itemIcon then
			local pSize = param.parent:getContentSize()
			itemIcon = newItem(pSize):align(display.CENTER, pSize.width * 0.5, pSize.height * 0.5):addTo(param.parent)
		else
			resetItem(itemIcon)
		end
		itemIcon.updateFunc = nil
		itemIcon.updateDesp = nil

		itemIcon.mShowEquipFlag = param.mShowEquipFlag
		itemIcon.mLevel = param.mLevel
		itemIcon.mZLevel = param.mZLevel
		itemIcon.showBetter = param.showBetter
		itemIcon.showBg = param.showBg
		itemIcon:getWidgetByName("lbl_upd_level"):setString(itemIcon.mLevel and itemIcon.mLevel>0 and "+"..itemIcon.mLevel or ""):setColor(cc.c3b(48,255,0))
		itemIcon:getWidgetByName("lbl_zl_level"):setString(itemIcon.mZLevel and itemIcon.mZLevel>0 and "+"..itemIcon.mZLevel or ""):setColor(cc.c3b(0,255,255))
		if param.pos or param.typeId then
			-- print("param.pos", param.pos, param.typeId, param.titleText)
			
			param.parent:setTouchEnabled(true)
			param.parent.itemIcon = itemIcon
			itemIcon:setTouchEnabled(false)
			-- itemIcon.itemCallBack	= param.itemCallBack
			itemIcon.iconType		= param.iconType
			itemIcon.tipsType		= param.tipsType
			itemIcon.customCallFunc = param.customCallFunc
			itemIcon.destoryCallFunc = param.destoryCallFunc
			itemIcon.callBack		= param.callBack
			itemIcon.doubleCall		= param.doubleCall
			if itemIcon.customCallFunc then
				itemIcon.doubleCall = itemIcon.customCallFunc
			end
			param.parent.hitTestCall    = param.hitTest
			itemIcon.updateDesp 	= param.updateDesp
			itemIcon.updateFunc 	= param.updateFunc
			itemIcon.compare 	= param.compare
			itemIcon.enmuPos	= param.enmuPos
			itemIcon.enmuItemType = param.enmuItemType
			
			if param.pos then
				UIItem.updateItemIconByPos(itemIcon, param.pos)
				cc.EventProxy.new(NetClient,itemIcon)
					:addEventListener(Notify.EVENT_ITEM_CHANGE, function (event)
						if canItemFresh(itemIcon.itemPos) then
							UIItem.handleItemChange(itemIcon, event)
						end
					end)
					:addEventListener(Notify.EVENT_ITEM_USELIMIT_CHANGE, function (event)
						UIItem.handleItemUseLimitChange(itemIcon, event)
					end)
			elseif param.typeId then 
				UIItem.updateItemIconByTypeId(itemIcon, param.typeId)
				cc.EventProxy.new(NetClient,itemIcon)
					:addEventListener(Notify.EVENT_NOTIFY_GETITEMDESP, function (event)
						if param.typeId == event.type_id then
							UIItem.updateItemIconByTypeId(itemIcon, event.type_id)
						end
					end)

				if param.num then
					UIItem.updateItemNum(itemIcon, param.num)
				end
				if param.bind then
					if bit.band(param.bind, Const.ITEM_FLAG_BIND) > 0 then
						itemIcon:getWidgetByName("img_bind_mark"):show()
					else
						itemIcon:getWidgetByName("img_bind_mark"):hide()
					end
				end
			end
			param.parent:setSwallowTouches(true)
			util.addMutilClickListener(param.parent, singleClickItem, doubleClickItem)
		end
	end
end

function UIItem.updateItemIconByPos(itemIcon, pos)
	-- print("updateItemIconByPos", pos)
	itemIcon.itemPos = pos
	local netItem = NetClient:getNetItem(pos)
	if netItem then
		itemIcon.mLevel = netItem.mLevel
		itemIcon.mZLevel = netItem.mZLevel

		UIItem.updateItemIconByTypeId(itemIcon, netItem.mTypeID)
		local mNum = netItem.mNumber
		local color = cc.c3b(0, 255, 0)
		local itemdef = NetClient:getItemDefByID(netItem.mTypeID)
		if itemdef then
			color = game.getColor(itemdef.mColor)
		end
		if itemIcon.mLevel > 0 then
			itemIcon:getWidgetByName("lbl_upd_level"):setString("+"..itemIcon.mLevel):setColor(cc.c3b(48,255,0))
		else
			itemIcon:getWidgetByName("lbl_upd_level"):setString("")
		end
		if netItem.mZLevel > 0 then
			itemIcon:getWidgetByName("lbl_zl_level"):setString(itemIcon.mZLevel):setColor(cc.c3b(0,255,255))
		else
			itemIcon:getWidgetByName("lbl_zl_level"):setString("")
		end
		-- local mColor = cc.c3b(0,255,0)
		UIItem.updateItemNum(itemIcon, mNum)

		if bit.band(netItem.mItemFlags, Const.ITEM_FLAG_BIND) > 0 then
			itemIcon:getWidgetByName("img_bind_mark"):show()
		else
			itemIcon:getWidgetByName("img_bind_mark"):hide()
		end
		handleRedPoint(itemIcon, netItem)
	else
		resetItem(itemIcon)
	end

	if NetClient:check_better_item(itemIcon.itemPos, true) then 
		itemIcon:getWidgetByName("img_better_equip"):show() 
	else
		if netItem and game.checkBoxMatch(netItem.mTypeID) then
			itemIcon:getWidgetByName("img_better_equip"):show() 
		else
			itemIcon:getWidgetByName("img_better_equip"):hide() 
		end
	end
	handleEquipFlag(itemIcon, netItem)
	if itemIcon.updateFunc then itemIcon.updateFunc(itemIcon.itemPos) end
end

function UIItem.updateItemNum(itemIcon, num ,color)
	-- print("/////////UIItem.updateItemNum/////////////", itemIcon.itemPos, num)
	local lblNum = itemIcon:getWidgetByName("lbl_num")
	local pSize = itemIcon:getContentSize()
	if num then
		if type(num) == "number" and num >= 1 then
			if num == 1 then
				lblNum:setString("")
			else
				if num > 9999 then
					lblNum:align(display.CENTER_BOTTOM, pSize.width * 0.5, pSize.height * 0.1)
				else
					lblNum:align(display.RIGHT_BOTTOM, pSize.width * 0.9, pSize.height * 0.1)
				end

				lblNum:setString(num)
			end
		elseif type(num) == "string" then
			lblNum:setString(num)
		end
		if color then
			lblNum:setColor(color)
		end
	else
		lblNum:setString("")
	end
end


function UIItem.updateItemIconByTypeId(itemIcon, typeId)
	-- print("updateItemIconByTypeId", typeId)
	local iconRes = "10000000"
	local itemdef = NetClient:getItemDefByID(typeId)
	
	if itemdef then iconRes = itemdef.mIconID end
	if iconRes == 29900000+1 or iconRes==82110000+24 or iconRes==11118900+21 or iconRes==11118900+91 or iconRes==25010000+10 or iconRes==25020000+10 or iconRes==25030000+10 or iconRes==25040000+10 or iconRes == 25050000+10 or iconRes == 25060000+10 then
		iconRes = iconRes +10             --上面的 可以随意加 随意换ID
	end
	if iconRes >=11100000+11 and iconRes<=11100000+18 then
			iconRes = iconRes +10
		end
	itemIcon.typeId = typeId
	itemIcon.resLoaded = false
	local path = "picicon/"..iconRes..".png"
	-- local imgIconInner = itemIcon:getWidgetByName("img_icon_inner"):hide()
	-- asyncload_callback(path, itemIcon, function(filepath, texture)
		-- if util.isObjectExist(itemIcon) and itemIcon.typeId then
			-- if not itemIcon.resLoaded then
				-- imgIconInner:show()
				itemIcon:getWidgetByName("img_icon"):loadTexture(path)
				-- local size = itemIcon:getWidgetByName("img_icon"):getContentSize()
				-- local pSize = itemIcon:getContentSize()
				-- itemIcon:getWidgetByName("img_icon"):setScale(pSize.width / size.width * 0.7)
			-- end
		
			-- local itemdef = NetClient:getItemDefByID(itemIcon.typeId)
			-- if itemdef and "picicon/"..itemdef.mIconID..".png" == filepath then
			-- 	itemIcon.resLoaded = true
			-- end
		-- end
	-- end)

	local filepath
	if itemdef and itemdef.mItemBg > 0 then
		filepath = string.format("picicon/iconbg%s.png", itemdef.mItemBg)
	elseif itemIcon:getWidgetByName("img_icon_bg") then
		itemIcon:getWidgetByName("img_icon_bg"):loadTexture("null", ccui.TextureResType.plistType):hide()
	end
	if itemIcon.showBg ~= nil then
		filepath = nil
		itemIcon:getWidgetByName("img_icon_bg"):loadTexture("null", ccui.TextureResType.plistType):hide()
	end
	if filepath then
		asyncload_callback(filepath, itemIcon, function(filepath, texture)
			if util.isObjectExist(itemIcon) and itemIcon.typeId then
				itemIcon:getWidgetByName("img_icon_bg"):show():loadTexture(filepath)
				local size = itemIcon:getWidgetByName("img_icon_bg"):getContentSize()
				local pSize = itemIcon:getContentSize()
				itemIcon:getWidgetByName("img_icon_bg"):setScale(1.0)
			end
		end)
	end

	if game.IsShield(typeId) or game.IsJewel(typeId) or game.IsCrittoken(typeId) then
		-- UIItem.updateSpecialItemName(itemIcon, typeId)
	end
	if itemdef and itemIcon.updateDesp then
		itemIcon.updateDesp(itemdef)
	end
	if itemIcon.showBetter then
		if NetClient:check_better_item({mTypeID = typeId, mLevel = itemIcon.mLevel}, true) then 
			itemIcon:getWidgetByName("img_better_equip"):show() 
		end
	end

end

function UIItem.handleItemChange(itemIcon, event)
	if event.pos == itemIcon.itemPos then
		-- if itemIcon.iconType == Const.ICONTYPE.UPGRADE then resetItem(itemIcon) return end
		if event.pos then 
			if util.isObjectExist(itemIcon) then
				UIItem.updateItemIconByPos(itemIcon, event.pos)
			end
		end
	end
	if itemIcon and itemIcon.itemPos then
		if NetClient:check_better_item(itemIcon.itemPos, true) then 
			itemIcon:getWidgetByName("img_better_equip"):show() 
		else
			local netItem = NetClient:getNetItem(itemIcon.itemPos)
			if netItem and game.checkBoxMatch(netItem.mTypeID) then
				itemIcon:getWidgetByName("img_better_equip"):show() 
			else
				itemIcon:getWidgetByName("img_better_equip"):hide() 
			end
		end
	end
end

function UIItem.handleItemUseLimitChange(itemIcon, event)
	if game.IsPosInBag(itemIcon.itemPos) and event.typeId == itemIcon.typeId then
		local netItem = NetClient:getNetItem(itemIcon.itemPos)
		if netItem then
			handleRedPoint(itemIcon, netItem)
		end
	end
end

function UIItem.updateItemIcon(itemIcon)
	local netItem = NetClient:getNetItem(itemIcon.itemPos)
	if netItem then
		local itemdef = NetClient:getItemDefByID(netItem.mTypeID)
		if not itemdef then print("not this item3") return end
	end
end

return UIItem